Ddoc

$(D_S Promoting D Projects (or Internet Marketing 101),

	$(P So you've written a cool project in D, and it's ready for others
	to use or to get involved with helping develop it further.
	Just posting a zip file isn't going to work. All your blood, sweat
	and effort will just go to waste.
	You'll need to provide a way for people who want to know about
	your project to be able to find it.
	)

	$(P The steps are:
	)

	$(OL
	$(LI Create a web page for the project)
	$(LI Let people know about it)
	)

<h3>Creating a Web Page</h3>

	$(P A good web page should include the following:
	)

	$(UL
	$(LI The keywords and phrases that someone who would be interested
	in your project might type into Google to find it.)

	$(LI The phrase $(B D programming language) somewhere on the page.
	This helps build the brand on the internet.
	If you just use $(B D), nobody will find it via search.)

	$(LI Screen shots of the program. Even better, for graphics
	and game demos, make a short video of it with
	$(LINK2 http://www.microsoft.com/windowsxp/using/moviemaker/default.mspx, Windows Movie Maker),
	which can capture movies directly from the screen.)

	$(LI List the capabilities of the package and what it's good for.)

	$(LI Identify who this package is intended for and why they'd
	want to use it.)

	$(LI Copyright and license information for any source code.
	If you intend for it to be
	$(LINK2 http://en.wikipedia.org/wiki/Public_domain, public domain),
	make sure to
	explicitly mark it so.)

	)

<h3>Promoting the Project</h3>

	$(P Submit the page or article to the following:
	)

	$(UL
	$(LI $(LINK2 http://www.digitalmars.com/pnews/indexing.php?server=news.digitalmars.com&group=digitalmars.D.announce, digitalmars.D.announce) newsgroup)
	$(LI $(LINK2 http://www.google.com/addurl/?continue=/addurl, Google web crawler))
	$(LI $(LINK2 http://www.google.com/codesearch/addcode, Google code search) for source code zips)
	$(LI $(LINK2 http://www.dzone.com/, dzone) developer news)
	$(LI $(LINK2 http://www.betamarker.com/, beta marker) for releases, including betas)
	$(LI $(LINK2 http://www.digg.com/, Digg) under the Developer category)
	$(LI $(LINK2 http://slashdot.org/, Slashdot) news for nerds)
	$(LI $(LINK2 http://www.gamedev.net/, gamedev.net) anything game related)
	$(LI $(LINK2 http://www.artima.com/, Artima Developer) developer articles)
	$(LI $(LINK2 http://www.download.com/, download.com) software downloads)
	$(LI $(LINK2 http://www.wikipedia.org/, Wikipedia) if it genuinely adds to an article on the subject)
	$(LI $(B comp.programming) newsgroup)
	)

	$(P Send me a cut-and-paste html snippet to place on
	$(LINK2 http://www.digitalmars.com/d/dlinks.html, dlinks).
	)

	$(P If your project is a conversion of an existing project to D,
	email the project leader of that existing project and suggest
	that he incorporate a link to your project on his page.
	)

	$(P For the absolutely most effective results, submit
	articles to:
	)

	$(UL
	$(LI $(LINK2 http://www.ddj.com, Dr. Dobb's Journal))
	$(LI $(LINK2 http://www.sdexpo.com/, SDWest))
	$(LI $(LINK2 http://www.oopsla.org/, OOPSLA))
	)

)

Macros:
	TITLE=D Programming Language - Promoting D Projects (or Internet Marketing 101)
	WIKI=PromotingDProjects

